resources = {}
resources._list = {}
resources.verbosity = 0 -- Verbosity level for extra logging

do
    if (resources.verbosity > 0) then
        print("\169192110255Resources [1]: Parsing current servertransfer.lst")
    end
    local fh = io.open("sys/servertransfer.lst", "r")
    for line in fh:lines() do
        line = line:gsub("^%s-//.*", "")
        line = line:gsub("^(.-)//.*", "%1")
        if (#line > 0) then
            if (resources.verbosity > -1) then
                print("\169192110255Resources: Adding '"..line.."' to transfer list")
            end
            table.insert(resources._list, line)
        end
    end
    fh:close()
    resources._origlist = {}
    for k, v in pairs(resources._list) do resources._origlist[k] = v end
end

function resources.addFile(path)
    if (resources.verbosity > -1) then
        print("\169192110255Resources: Adding '"..path.."' to transfer list")
    end
    table.insert(resources._list, path)
    local fh = io.open("sys/servertransfer.lst", "a")
    fh:write("\n"..path)
    fh:close()
end

function resources.removeFile(path)
    if (resources.verbosity > -1) then
        print("\169192110255Resources: Removing '"..path.."' from transfer list")
    end
    for k, f in pairs(resources._list) do
        if (f == path) then
            table.remove(resources._list, k)
            break
        end
    end
    local fh = io.open("sys/servertransfer.lst", "w")
    fh:write(table.concat(resources._list, "\n"))
    fh:close()
end

function resources.isStaged(path)
    for k, v in pairs(resources_list) do
        if (v == path) then
            return true
        end
    end
    return false
end

addhook("shutdown", "resources._restore")
function resources._restore()
    if (resources.verbosity > 0) then
        print("\169192110255Resources [1]: Restoring original servertransfer.lst")
    end
    local fh = io.open("sys/servertransfer.lst", "w")
    fh:write(table.concat(resources._origlist, "\n"))
    fh:close()
end